/******************************************************************
*
* BIN2HEX.C
* ========
* BIN2HEX-Konverter (C) Wickenhuser
* Konvertiert ein Binaerfile in ein Hexfile
*
*BIN2HEX infile outfile
*BIN2HEX a.bin a.hex
*
* PC-Compiler: Borland C++ 3.1
*****************************************************************/

#include <sys\stat.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>			 /* getvect()... */
#include <conio.h>

#define VERSION  "1995, V1.0"

typedef unsigned int uint;
typedef unsigned char uchar;

/*********************************************************************
* M A I N
*********************************************************************/
int main(argc,argv)
int argc;
char **argv;{
	FILE *infile,*outfile;				/* Sourcedatei */
	struct stat statbuf;
	long len;
	uchar *code,*pcode;
	long load_adr;
	long i,cs,ol,max;

	printf("*** BIN2HEX-Konverter (C) Wickenhuser ***\n\n",VERSION);

	/* Sost: Kein Test: Ernstfall */
	if(argc!=3){
		puts("Aufruf: BIN2HEX infile outfile");
		puts("Bsp.:   BIN2HEX a.bin a.hex");
		exit(-1);
	}

	if((infile=fopen(argv[1],"rb"))==NULL) {
		printf("*** Fehler: '%s': Datei oeffnen!\007\n",argv[1]);
		exit(-1);
	}
	if((outfile=fopen(argv[2],"w"))==NULL) {	/* Textdatei! */
		printf("*** Fehler: '%s': Datei oeffnen!\007\n",argv[2]);
		exit(-1);
	}

	 /* Filedaten ermitteln */
	 if(fstat(fileno(infile), &statbuf)==-1){
	 printf("*** Fehler: Dateistatus!\007\n");
		 exit(-1);
	 }

	 len=statbuf.st_size;
	 if(len>(65536L-6L) || len<2){	     /**** 2 Bytes Reserve ****/
		 puts("\007*** Fehler: Datei zu gross/klein!\n");
		 exit(-1);
	}

	if((code = (uchar*)malloc((uint)len+4)) ==NULL){
		 puts("\007*** Fehler: Speicher voll!");
		 exit(-1);
	}

	 cs=len;
	 pcode=code;
	 while(cs){
		 max=cs;
		 if(max>16384) max=16384;
		 if(fread(pcode,(uint)max,1,infile)!=1){
			 puts("*** Fehler: Datei Lesefehler!\007");
			 exit(-1);
		 }
		 cs-=max;
		 pcode+=(uint)max;
	 }
	fclose(infile);
	load_adr=(code[len-1]+code[len-2]*256)&0xFFFF;
	len-=2;
	printf("Ladeadresse: $%04lx\n",load_adr);
	printf("Code-Laenge: %ld Bytes\n",len);

	pcode=code;
	while(len){
		ol=len;
		if(ol>32) ol=32;
		fprintf(outfile,":%02lX%04lX00",ol,load_adr);
		cs=ol;
		cs+=load_adr&255;
		cs+=(load_adr/256);
		load_adr+=ol;
		for(i=0;i<ol;i++){
			fprintf(outfile,"%02X",*pcode);
			cs+=*pcode;
			pcode++;
		}
		fprintf(outfile,"%02X\n",(uchar)(-cs));
		len-=ol;
	}
	fputs(":00000001FF\n",outfile);
	fclose(outfile);
	return 0;
}
